{
    'targets': [{
        'target_name': 'ocrxpress',
        'sources': ['src/ocrxpress.cpp', 'src/asyncworkers.cpp', 'src/util.cpp'],
        'include_dirs': [ '<!(node -e "require(\'nan\')")', 'src' ],
        'cflags': ['-std=c++11'],
        'cflags_cc': ['-fexceptions'],
        'conditions': [
            ['OS=="linux"', {
                'libraries': [
                    '-static-libgcc -static-libstdc++',
                    '-L../dependencies/linux64',
                    '-locrxpress-nodejs',
                ],
                'ldflags': [ '-Wl,-rpath,<(module_root_dir)/dependencies/linux64' ],
            }],
            ['OS=="win"', {
                'defines': ["LIBOCRX_IMPORTS"],
                'libraries': ['ocrxpress-nodejs'],
                'library_dirs': ['dependencies/win64'],
                'copies': [{
                    'files': ['dependencies/win64/ocrxpress-nodejs.dll'],
                    'destination': 'build/Debug'
                },{
                    'files': ['dependencies/win64/ocrxpress-nodejs.dll'],
                    'destination': 'build/Release'
                }],
            }]
        ]
    }]
}
