// *******************************************************************'
// Copyright 1996-2018 Accusoft Corporation. All rights reserved.    *'
// This sample code is provided to Accusoft licensees "as is"        *'
// with no restrictions on use or modification. No warranty for      *'
// use of this sample code is provided by Accusoft.                  *'
//                                                                   *'
// SAMPLE PURPOSE                                                    *'
//                                                                   *'
// This sample illustrates how to read in a text-based image and     *'
// export that data to memory, using Accusoft's OCR Xpress.          *'
//****************************************************************** *'
var ocrx = require('ocr');
require('ocr-lang-eng');

params = {};
// Get command line input.
if (process.argv.length != 3 || process.argv[2] == '-h' || process.argv[2] == '-help') {
    console.log('********************************************************************');
    console.log('Usage:  \t'  + 'node memory.js <inputFile>');
    console.log('Example:\t' + 'node memory.js  ../images/color.bmp');
    console.log('Run Example by default:\t' + 'node memory.js  ../images/color.bmp');
    console.log('********************************************************************');
    // Set default value.
    params.input  = '../images/color.bmp';
}
else {
    params.input = process.argv[2];
}

// Initialize any licensing that needs to be set.
// ocrx.setSolutionName('<Solution name goes here>');
// ocrx.setSolutionKey(0x01234567, 0x01234567, 0x01234567, 0x01234567);

// Recognize the input image and output result to memory.
ocrx.recognize(params, function(err, document) {
    if (err) {
        console.error(err);
    }
    else {        
        console.log(' === Print out the 2nd line === ');
        console.log(document.getTextLines()[1].text);
        console.log(' === Print out each word of the 3rd line === ');
        document.getTextLines()[2].getWords().forEach(function(element) {
            console.log(element.text);
        });
    }
});
